<?php

ini_set('display_errors', 1);

// Set errors
$intErrors = 0;
$strErrorMsg = "";

require_once('TwitterAPIExchange.php');
require_once('GetSharedParams.php');

// Get specific parameters:

if ( isset( $_GET["strTwitterID"]) && !empty($_GET['strTwitterID'])) {
	$strTwitterID = $_GET["strTwitterID"];
	$getfield = 'user_id=' . $strTwitterID;
} elseif ( isset($_GET["strScreenName"]) && !empty($_GET['strScreenName'])) {
	$strScreenName = $_GET["strScreenName"];
	$getfield = 'screen_name=' . $strScreenName;
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "either strTwitterID or strScreenName missing, ";	
}

$getfield = '?' . $getfield;

if ($intErrors > 0 ) {
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
	echo "	<us>" . "\r\n";
	echo "		<u>" . "\r\n";
	echo "			<code>params</code>" . "\r\n";
	echo "			<message>" . $intErrors  . " parameter error(s) - " . $strErrorMsg . "</message>" . "\r\n";
	echo "		</u>" . "\r\n";
	echo "	</us>";
	die;
}

/** Set access tokens here - see: https://dev.twitter.com/apps/ **/
$settings = array(
    'oauth_access_token' => $oat,
    'oauth_access_token_secret' => $oats,
    'consumer_key' => $ck,
    'consumer_secret' => $cs
);


echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" . "\r\n";
echo "	<ls>" . "\r\n";
echo "		<fake>" . "\r\n"; // add this empty record to ensure there is always some data
echo "			<code>0</code>" . "\r\n"; // no errors
echo "		</fake>" . "\r\n";

$url = 'https://api.twitter.com/1.1/lists/list.json';

$requestMethod = 'GET';
$twitter = new TwitterAPIExchange($settings);

$users=$twitter->setGetfield($getfield)
			 ->buildOauth($url, $requestMethod)
			 ->performRequest();

$arrayContent = json_decode($users, true);
		 
if (array_key_exists('errors', $arrayContent)) {
	
	echo "		<l>" . "\r\n";
	echo "			<code>" . $arrayContent['errors'][0]['code'] . "</code>" . "\r\n";
	echo "			<message>" . $arrayContent['errors'][0]['message'] . "</message>" . "\r\n";
	echo "		</l>" . "\r\n";
	echo "	</ls>" . "\r\n";
	die;
}

$arrayCount = count($arrayContent);
$arrayCurPos = 0;

function CleanXML($strXML) {

	$strXML = str_replace("&","&amp;",$strXML);
	$strXML = str_replace("<","&lt;",$strXML);
	$strXML = str_replace(">","&gt;",$strXML);
	$strXML = str_replace('"',"&quot;",$strXML);
	$strXML = str_replace("'","&apos;",$strXML);
	$strXML = str_replace("\r","&lt;br&gt;",$strXML);
	$strXML = str_replace("\n","&lt;br&gt;",$strXML);

	return $strXML;
	
}

while ($arrayCurPos < $arrayCount){
	
	echo "		<l>" . "\r\n";
	echo "			<code>0</code>" . "\r\n"; // no errors
	echo "			<id_str>" . $arrayContent[$arrayCurPos]['id_str'] . "</id_str>" . "\r\n";
	echo "			<name>" . CleanXML($arrayContent[$arrayCurPos]['name']) . "</name>" . "\r\n";
	echo "			<full_name>" . CleanXML($arrayContent[$arrayCurPos]['full_name']) . "</full_name>" . "\r\n";
	echo "			<description>" . CleanXML($arrayContent[$arrayCurPos]['description']) . "</description>" . "\r\n";
	echo "			<mode>" . CleanXML($arrayContent[$arrayCurPos]['mode']) . "</mode>" . "\r\n";
	echo "			<member_count>" . $arrayContent[$arrayCurPos]['member_count'] . "</member_count>" . "\r\n";
	echo "			<subscriber_count>" . $arrayContent[$arrayCurPos]['subscriber_count'] . "</subscriber_count>" . "\r\n";
	echo "		</l>" . "\r\n";
	$arrayCurPos = $arrayCurPos + 1;
}

echo "	</ls>" . "\r\n";

//echo var_dump($arrayContent);

?>